package  
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 400, height = 300)]
	public class Basic extends Sprite
	{
		private var set1a:Triangle, set1b:Circle, set2a:Triangle, set2b:Circle;
		private var intersec:Circle
		private var v1:Vector2D, v2:Vector2D;
			
		public function Basic() 
		{
			set1a = new Triangle(); set1b = new Circle(0xFF0000);
			set2a = new Triangle(); set2b = new Circle(0x00FF00);
			
			set1a.x = stage.stage.stageWidth * 0.3; set1a.y = stage.stage.stageHeight * 0.2;
			set1b.x = stage.stage.stageWidth * 0.3; set1b.y = stage.stage.stageHeight * 0.5; 
			set2a.x = stage.stage.stageWidth * 0.7; set2a.y = stage.stage.stageHeight * 0.4; 
			set2b.x = stage.stage.stageWidth * 0.5; set2b.y = stage.stage.stageHeight * 0.3; 
			reorient();
			
			addChild(set1a); addChild(set1b);
			addChild(set2a); addChild(set2b);
			draw();
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mov);
			stage.addEventListener(MouseEvent.MOUSE_UP, mov);
			
			intersec = new Circle(0, 5); addChild(intersec);
		}
		
		private function mov(e:MouseEvent):void 
		{
			var isStage:Boolean = e.target is Stage
			if (!isStage) {
				if (e.type == "mouseDown") {
					e.target.startDrag();
					this.addEventListener(MouseEvent.MOUSE_MOVE, update)
				}
				else if (e.type == "mouseUp") {
					e.target.stopDrag();
					this.removeEventListener(MouseEvent.MOUSE_MOVE, update)
				}
			}
		}
		
		private function update(e:MouseEvent):void 
		{
			draw();
			recalculation();
		}
		
		private function recalculation ():void {
			reorient();
			
		/*Explain:
			 * v1 & v2 are vectors to represent both line segments
			 * v1 joins set1b(tail) to set1a (head) - analogous to vector k in diagram
			 * v2 joins set2b(tail) to set2a (head)
			 * toV2b is vector analogous to that of vector j in diagram
			 */
			var perp1:Number = v1.perpProduct(v2.normalise());
			var toV2b:Vector2D = new Vector2D (set2b.x - set1b.x, set2b.y - set1b.y);
			var perp2:Number = toV2b.perpProduct(v2.normalise());
			
		/*Explain:
			 * length is calculated from the similar triangles ratio
			 * it is later used as magnitude for a vector 
			 * that points in v1's direction
			 */
			var length:Number = perp2 / perp1 * v1.getMagnitude();
			var length_v1:Vector2D = v1.clone();
			length_v1.setMagnitude(length);
			
		/*Explain
			 * extend to locate the exact location of collision point
			 */
			intersec.x = set1b.x + length_v1.x;
			intersec.y = set1b.y + length_v1.y;
		}
		
		private function draw():void {
			graphics.clear();
			graphics.lineStyle(1);
			graphics.drawPath(new <int>[1,2,1,2], new <Number>[set1a.x, set1a.y, set1b.x, set1b.y, set2a.x, set2a.y,set2b.x,set2b.y]);
		}
		
		private function reorient():void 
		{
			v1 = new Vector2D (set1a.x - set1b.x, set1a.y - set1b.y); set1a.rotation = Math2.degreeOf(v1.getAngle())
			v2 = new Vector2D (set2a.x - set2b.x, set2a.y - set2b.y); set2a.rotation = Math2.degreeOf(v2.getAngle())
		}
	}

}