package  
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 500, height = 400)]
	public class Basic2 extends Sprite
	{
		private var triX:Triangle, triY:Triangle;
		private var axes:Sprite
		private var triX2:Triangle, triY2:Triangle;
		private var onX:Vector2D, onY:Vector2D, origin:Vector2D;
		
		public function Basic2() 
		{
			drawAxes1();
			
			origin = new Vector2D(stage.stageWidth * 0.5, stage.stageHeight * 0.6);
			onX = new Vector2D(200, -30);
			onY = onX.getNormal(false);
			triX2 = new Triangle(0); triX2.name = "ax";  addChild(triX2);
			triY2 = new Triangle(0x999999); triY2.name = "ay"; addChild(triY2);
			drawAxes2();
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mov);
			stage.addEventListener(MouseEvent.MOUSE_UP, mov);
		}
		
		private function mov(e:MouseEvent):void 
		{
			if (e.target.name == "ax") {
				if (e.type == "mouseDown") {
					e.target.startDrag()
					e.target.addEventListener(MouseEvent.MOUSE_MOVE, update)
				}
				else if (e.type == "mouseUp") {
					e.target.stopDrag()
					e.target.removeEventListener(MouseEvent.MOUSE_MOVE, update)
				}
			}
		}
		
		private function update(e:MouseEvent):void 
		{
			onX = new Vector2D (mouseX - origin.x, mouseY - origin.y);
			onY = onX.getNormal(false);
			drawAxes2();
		}
		
		private function drawAxes2():void 
		{
			triX2.x = origin.x + onX.x; triX2.y = origin.y + onX.y; triX2.rotation = Math2.degreeOf(onX.getAngle())
			triY2.x = origin.x + onY.x; triY2.y = origin.y + onY.y; triY2.rotation = Math2.degreeOf(onY.getAngle())
			
			graphics.clear();
			graphics.lineStyle(1);
			graphics.drawPath(new <int>[1,2,2], new <Number>[origin.x+onX.x,origin.y+onX.y,origin.x,origin.y,origin.x+onY.x,origin.y+onY.y]);
			
			var proj:Number = onY.projectionOn(new Vector2D( -1, 0));
			var perp:Number = onX.perpProduct(new Vector2D(1,0));
			
			var hor:Vector2D = new Vector2D(-1,0); hor.setMagnitude(proj);
			var vert:Vector2D = new Vector2D(0, -1); vert.setMagnitude(perp);
			
			graphics.lineStyle(4, 0xFF0000);
			graphics.drawPath(new <int>[1,2,1,2], new <Number>[
					triX2.x, triX2.y, 
					triX2.x + vert.x, triX2.y + vert.y, 
					origin.x, origin.y, 
					origin.x + hor.x, origin.y + hor.y]);
			
			graphics.lineStyle(2, 0xFF0000, 0.5);
			graphics.drawPath(new <int>[1,2,1,2], new <Number>[
					origin.x, origin.y,
					triX2.x + vert.x, triX2.y + vert.y, 
					triY2.x, triY2.y,
					origin.x + hor.x, origin.y + hor.y]);
		}
		
		private function drawAxes1():void 
		{
			var origin:Vector2D = new Vector2D(stage.stageWidth * 0.5, stage.stageHeight * 0.6);
			var onX:Vector2D = new Vector2D(200, 0);
			var onY:Vector2D = onX.getNormal(false);
			
			axes = new Sprite(); addChild(axes);
			axes.graphics.lineStyle(1);
			axes.graphics.drawPath(new <int>[1,2,2], new <Number>[origin.x+onX.x,origin.y+onX.y,origin.x,origin.y,origin.x+onY.x,origin.y+onY.y]);
			
			triX = new Triangle(); addChild(triX);
			triY = new Triangle(); addChild(triY);
			triX.x = origin.x + onX.x; triX.y = origin.y + onX.y;
			triY.x = origin.x + onY.x; triY.y = origin.y + onY.y; triY.rotation = -90
		}
		
	}

}