package  
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageScaleMode
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 400, height = 300)]
	public class Basic_matrix extends Sprite
	{
		private var set1a:Triangle, set1b:Circle, set2a:Triangle, set2b:Circle;
		private var intersec:Circle
		private var v1:Vector2D, v2:Vector2D;
			
		public function Basic_matrix() 
		{
			stage.scaleMode = StageScaleMode.NO_SCALE
			set1a = new Triangle(); set1b = new Circle(0xFF0000);
			set2a = new Triangle(); set2b = new Circle(0x00FF00);
			
			set1a.name = "head"; set1b.name = "tail";
			
			set1a.x = stage.stage.stageWidth * 0.3; set1a.y = stage.stage.stageHeight * 0.2;
			set1b.x = stage.stage.stageWidth * 0.3; set1b.y = stage.stage.stageHeight * 0.5; 
			set2a.x = stage.stage.stageWidth * 0.7; set2a.y = stage.stage.stageHeight * 0.4; 
			set2b.x = stage.stage.stageWidth * 0.5; set2b.y = stage.stage.stageHeight * 0.3; 
			reorient();
			
			addChild(set1a); addChild(set1b);
			addChild(set2a); addChild(set2b);
			draw();
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mov);
			stage.addEventListener(MouseEvent.MOUSE_UP, mov);
			
			intersec = new Circle(0, 5); addChild(intersec);
		}
		
		private function mov(e:MouseEvent):void 
		{
			var isStage:Boolean = e.target is Stage
			if (!isStage) {
				if (e.type == "mouseDown") {
					e.target.startDrag();
					trace(e.target.name);
					this.addEventListener(MouseEvent.MOUSE_MOVE, update)
				}
				else if (e.type == "mouseUp") {
					e.target.stopDrag();
					this.removeEventListener(MouseEvent.MOUSE_MOVE, update)
				}
			}
		}
		
		private function update(e:MouseEvent):void 
		{
			draw();
			recalculation();
		}
		
		private function recalculation ():void {
			reorient();
			
			var E:Number = set1b.y - set1a.y;
			var F:Number = set1a.x - set1b.x;
			var G:Number = set1a.x * set1b.y - set1a.y * set1b.x;
			
			var P:Number = set2b.y - set2a.y;
			var Q:Number = set2a.x - set2b.x;
			var R:Number = set2a.x * set2b.y - set2a.y * set2b.x;
			
			var T:Matrix = new Matrix(E, P, F, Q);
			T.invert();
			var S:Matrix = new Matrix();
			S.a = G; S.b = R;
			S.concat(T);	//multiplying the matrix
			intersec.x = S.a;
			intersec.y = S.b;
		}
		
		private function draw():void {
			graphics.clear();
			graphics.lineStyle(1);
			graphics.drawPath(new <int>[1,2,1,2], new <Number>[set1a.x, set1a.y, set1b.x, set1b.y, set2a.x, set2a.y,set2b.x,set2b.y]);
		}
		
		private function reorient():void 
		{
			v1 = new Vector2D (set1a.x - set1b.x, set1a.y - set1b.y); set1a.rotation = Math2.degreeOf(v1.getAngle())
			v2 = new Vector2D (set2a.x - set2b.x, set2a.y - set2b.y); set2a.rotation = Math2.degreeOf(v2.getAngle())
		}
	}

}